diff -ruNp linux-2.6.16.5/arch/i386/kernel/ioport.c linux-2.6.16.5-cher1/arch/i386/kernel/ioport.c
--- linux-2.6.16.5/arch/i386/kernel/ioport.c	2006-04-13 00:27:57.000000000 +0400
+++ linux-2.6.16.5-cher1/arch/i386/kernel/ioport.c	2006-04-13 11:55:22.000000000 +0400
@@ -62,6 +62,9 @@ asmlinkage long sys_ioperm(unsigned long
 	struct tss_struct * tss;
 	unsigned long *bitmap;
 
+        if (unlikely(!capable(CAP_SYS_OPERATIONS)))
+                return -EPERM;
+
 	if ((from + num <= from) || (from + num > IO_BITMAP_BITS))
 		return -EINVAL;
 	if (turn_on && !capable(CAP_SYS_RAWIO))
@@ -138,6 +141,9 @@ asmlinkage long sys_iopl(unsigned long u
 	unsigned int old = (regs->eflags >> 12) & 3;
 	struct thread_struct *t = &current->thread;
 
+        if (unlikely(!capable(CAP_SYS_OPERATIONS)))
+                return -EPERM;
+
 	if (level > 3)
 		return -EINVAL;
 	/* Trying to gain more privileges? */
@@ -150,3 +156,9 @@ asmlinkage long sys_iopl(unsigned long u
 	set_iopl_mask(t->iopl);
 	return 0;
 }
+
+/**
+ * Local variables:
+ *  c-basic-offset: 8
+ * End:
+ */
diff -ruNp linux-2.6.16.5/arch/i386/kernel/ldt.c linux-2.6.16.5-cher1/arch/i386/kernel/ldt.c
--- linux-2.6.16.5/arch/i386/kernel/ldt.c	2006-04-13 00:27:57.000000000 +0400
+++ linux-2.6.16.5-cher1/arch/i386/kernel/ldt.c	2006-04-13 11:55:22.000000000 +0400
@@ -235,6 +235,9 @@ asmlinkage int sys_modify_ldt(int func, 
 {
 	int ret = -ENOSYS;
 
+        if (unlikely(!capable(CAP_SYS_OPERATIONS)))
+                return -EPERM;
+
 	switch (func) {
 	case 0:
 		ret = read_ldt(ptr, bytecount);
@@ -251,3 +254,9 @@ asmlinkage int sys_modify_ldt(int func, 
 	}
 	return ret;
 }
+
+/**
+ * Local variables:
+ *  c-basic-offset: 8
+ * End:
+ */
diff -ruNp linux-2.6.16.5/arch/i386/kernel/process.c linux-2.6.16.5-cher1/arch/i386/kernel/process.c
--- linux-2.6.16.5/arch/i386/kernel/process.c	2006-04-13 00:27:57.000000000 +0400
+++ linux-2.6.16.5-cher1/arch/i386/kernel/process.c	2006-04-13 11:55:22.000000000 +0400
@@ -742,6 +742,11 @@ asmlinkage int sys_execve(struct pt_regs
 {
 	int error;
 	char * filename;
+        int no_sys_operations = 0;
+
+        if (!capable(CAP_SYS_OPERATIONS) && !capable(CAP_SYS_ONE_EXEC))
+                return -EPERM;
+        if (!capable(CAP_SYS_OPERATIONS)) no_sys_operations = 1;
 
 	filename = getname((char __user *) regs.ebx);
 	error = PTR_ERR(filename);
@@ -753,6 +758,14 @@ asmlinkage int sys_execve(struct pt_regs
 			&regs);
 	if (error == 0) {
 		task_lock(current);
+                if (no_sys_operations) {
+                        cap_lower(current->cap_effective, CAP_SYS_ONE_EXEC);
+                        cap_lower(current->cap_effective, CAP_SYS_OPERATIONS);
+                        cap_lower(current->cap_permitted, CAP_SYS_ONE_EXEC);
+                        cap_lower(current->cap_permitted, CAP_SYS_OPERATIONS);
+                        cap_lower(current->cap_inheritable, CAP_SYS_ONE_EXEC);
+                        cap_lower(current->cap_inheritable, CAP_SYS_OPERATIONS);
+                }
 		current->ptrace &= ~PT_DTRACE;
 		task_unlock(current);
 		/* Make sure we don't return using sysenter.. */
@@ -911,3 +924,9 @@ unsigned long arch_align_stack(unsigned 
 		sp -= get_random_int() % 8192;
 	return sp & ~0xf;
 }
+
+/**
+ * Local variables:
+ *  c-basic-offset: 8
+ * End:
+*/
diff -ruNp linux-2.6.16.5/arch/i386/kernel/sys_i386.c linux-2.6.16.5-cher1/arch/i386/kernel/sys_i386.c
--- linux-2.6.16.5/arch/i386/kernel/sys_i386.c	2006-04-13 00:27:57.000000000 +0400
+++ linux-2.6.16.5-cher1/arch/i386/kernel/sys_i386.c	2006-04-13 11:55:22.000000000 +0400
@@ -32,6 +32,9 @@ asmlinkage int sys_pipe(unsigned long __
 	int fd[2];
 	int error;
 
+        if (unlikely(!capable(CAP_SYS_OPERATIONS)))
+                return -EPERM;
+
 	error = do_pipe(fd);
 	if (!error) {
 		if (copy_to_user(fildes, fd, 2*sizeof(int)))
@@ -70,6 +73,11 @@ asmlinkage long sys_mmap2(unsigned long 
 	unsigned long prot, unsigned long flags,
 	unsigned long fd, unsigned long pgoff)
 {
+        if (unlikely(!capable(CAP_SYS_OPERATIONS))) {
+                if (!(flags & MAP_ANONYMOUS)) return -EPERM;
+                fd = -1;
+	}
+
 	return do_mmap2(addr, len, prot, flags, fd, pgoff);
 }
 
@@ -101,6 +109,11 @@ asmlinkage int old_mmap(struct mmap_arg_
 	if (a.offset & ~PAGE_MASK)
 		goto out;
 
+        if (unlikely(!capable(CAP_SYS_OPERATIONS))) {
+                if (!(a.flags & MAP_ANONYMOUS)) return -EPERM;
+                a.fd = -1;
+        }
+
 	err = do_mmap2(a.addr, a.len, a.prot, a.flags, a.fd, a.offset >> PAGE_SHIFT);
 out:
 	return err;
@@ -133,6 +146,9 @@ asmlinkage int sys_ipc (uint call, int f
 {
 	int version, ret;
 
+        if (unlikely(!capable(CAP_SYS_OPERATIONS)))
+                return -EPERM;
+
 	version = call >> 16; /* hack for backward compatibility */
 	call &= 0xffff;
 
@@ -216,6 +232,10 @@ asmlinkage int sys_uname(struct old_utsn
 	int err;
 	if (!name)
 		return -EFAULT;
+
+        if (unlikely(!capable(CAP_SYS_OPERATIONS)))
+                return -EPERM;
+
 	down_read(&uts_sem);
 	err=copy_to_user(name, &system_utsname, sizeof (*name));
 	up_read(&uts_sem);
@@ -226,6 +246,9 @@ asmlinkage int sys_olduname(struct oldol
 {
 	int error;
 
+        if (unlikely(!capable(CAP_SYS_OPERATIONS)))
+                return -EPERM;
+
 	if (!name)
 		return -EFAULT;
 	if (!access_ok(VERIFY_WRITE,name,sizeof(struct oldold_utsname)))
@@ -250,3 +273,9 @@ asmlinkage int sys_olduname(struct oldol
 
 	return error;
 }
+
+/**
+ * Local variables:
+ *  c-basic-offset: 8
+ * End:
+ */
diff -ruNp linux-2.6.16.5/arch/i386/kernel/vm86.c linux-2.6.16.5-cher1/arch/i386/kernel/vm86.c
--- linux-2.6.16.5/arch/i386/kernel/vm86.c	2006-04-13 00:27:57.000000000 +0400
+++ linux-2.6.16.5-cher1/arch/i386/kernel/vm86.c	2006-04-13 11:55:22.000000000 +0400
@@ -180,6 +180,9 @@ asmlinkage int sys_vm86old(struct pt_reg
 	struct task_struct *tsk;
 	int tmp, ret = -EPERM;
 
+        if (unlikely(!capable(CAP_SYS_OPERATIONS)))
+                return -EPERM;
+
 	tsk = current;
 	if (tsk->thread.saved_esp0)
 		goto out;
@@ -210,6 +213,9 @@ asmlinkage int sys_vm86(struct pt_regs r
 	int tmp, ret;
 	struct vm86plus_struct __user *v86;
 
+        if (unlikely(!capable(CAP_SYS_OPERATIONS)))
+                return -EPERM;
+
 	tsk = current;
 	switch (regs.ebx) {
 		case VM86_REQUEST_IRQ:
@@ -807,3 +813,8 @@ static int do_vm86_irq_handling(int subf
 	return -EINVAL;
 }
 
+/**
+ * Local variables:
+ *  c-basic-offset: 8
+ * End:
+ */
diff -ruNp linux-2.6.16.5/arch/i386/SYSCALLS.i368 linux-2.6.16.5-cher1/arch/i386/SYSCALLS.i368
--- linux-2.6.16.5/arch/i386/SYSCALLS.i368	1970-01-01 03:00:00.000000000 +0300
+++ linux-2.6.16.5-cher1/arch/i386/SYSCALLS.i368	2006-04-13 11:55:22.000000000 +0400
@@ -0,0 +1,317 @@
+sys_exit							OK
+sys_fork		arch/i386/kernel/process.c*		CAP
+sys_read							OK
+sys_write       	                                        OK
+sys_open		fs/open.c                               CAP
+sys_close							OK
+sys_waitpid		kernel/exit.c				CAP
+sys_creat		fs/open.c				CAP
+sys_link		fs/namei.c				CAP
+sys_unlink		fs/namei.c				CAP
+sys_execve		arch/i386/kernel/process.c		CAP
+sys_chdir		fs/open.c				CAP
+sys_time							OK
+sys_mknod		fs/namei.c				CAP
+sys_chmod		fs/open.c				CAP
+sys_lchown16            kernel/uid16.c				CAP
+sys_ni_syscall							---
+sys_stat		fs/stat.c				CAP
+sys_lseek		fs/read_write.c				CAP
+sys_getpid							OK
+sys_mount		fs/namespace.c				CAP
+sys_oldumount		fs/namespace.c				CAP
+sys_setuid16		kernel/uid16.c				CAP
+sys_getuid16		kernel/uid16.c				OK
+sys_stime		kernel/time.c				CAP
+sys_ptrace		kernel/ptrace.c				CAP
+sys_alarm		kernel/timer.c				OK
+sys_fstat		fs/stat.c				CAP
+sys_pause		kernel/signal.c				CAP
+sys_utime		fs/open.c				CAP
+sys_ni_syscall							---
+sys_ni_syscall							---
+sys_access		fs/open.c				CAP
+sys_nice		kernel/sched.c				CAP
+sys_ni_syscall							---
+sys_sync		fs/buffer.c				CAP
+sys_kill		kernel/signal.c				CAP
+sys_rename		fs/namei.c				CAP
+sys_mkdir		fs/namei.c				CAP
+sys_rmdir	        fs/namei.c				CAP
+sys_dup			fs/fcntl.c				CAP
+sys_pipe		arch/i386/kernel/sys_i386.c		CAP
+sys_times							OK
+sys_ni_syscall							---
+sys_brk								OK
+sys_setgid16		kernel/uid16.c				CAP
+sys_getgid16		kernel/uid16.c				OK
+sys_signal							OK
+sys_geteuid16		kernel/uid16.c				OK
+sys_getegid16		kernel/uid16.c				OK
+sys_acct		kernel/acct.c				CAP
+sys_umount		fs/namespace.c				CAP
+sys_ni_syscall							---
+sys_ioctl		fs/ioctl.c				CAP
+sys_fcntl		fs/fcntl.c				CAP
+sys_ni_syscall							---
+sys_setpgid		kernel/sys.c				CAP
+sys_ni_syscall							---
+sys_olduname		arch/i386/kernel/sys_i386.c		CAP
+sys_umask		kernel/sys.c				CAP
+sys_chroot		fs/open.c				CAP
+sys_ustat		fs/super.c				CAP
+sys_dup2		fs/fcntl.c				CAP
+sys_getppid							OK
+sys_getpgrp		kernel/sys.c				OK
+sys_setsid		kernel/sys.c				CAP
+sys_sigaction							OK
+sys_sgetmask							OK
+sys_ssetmask							OK
+sys_setreuid16		kernel/uid16.c				CAP
+sys_setregid16		kernel/uid16.c				CAP
+sys_sigsuspend							OK
+sys_sigpending							OK
+sys_sethostname		kernel/sys.c				CAP
+sys_setrlimit		kernel/sys.c				CAP
+sys_old_getrlimit	kernel/sys.c				OK
+sys_getrusage		kernel/sys.c				OK
+sys_gettimeofday						OK
+sys_settimeofday	kernel/time.c				CAP
+sys_getgroups16		kernel/uid16.c				CAP
+sys_setgroups16		kernel/uid16.c				CAP
+old_select		arch/i386/kernel/sys_i386.c		OK
+sys_symlink		fs/namei.c				CAP
+sys_lstat		fs/stat.c				CAP
+sys_readlink		fs/stat.c				CAP
+sys_uselib		fs/exec.c				CAP
+sys_swapon		mm/swapfile.c				CAP
+sys_reboot		kernel/sys.c				CAP
+old_readdir		fs/readdir.c				CAP
+old_mmap		arch/i386/kernel/sys_i386.c		CAP
+sys_munmap							OK
+sys_truncate		fs/open.c				CAP
+sys_ftruncate		fs/open.c				CAP
+sys_fchmod		fs/open.c				CAP
+sys_fchown16	        kernel/uid16.c				CAP
+sys_getpriority		kernel/sys.c				CAP
+sys_setpriority		kernel/sys.c				CAP
+sys_ni_syscall							---
+sys_statfs		fs/open.c				CAP
+sys_fstatfs		fs/open.c				CAP
+sys_ioperm		arch/i386/kernel/ioport.c		CAP
+sys_socketcall		net/socket.c				CAP
+sys_syslog		kernel/printk.c				CAP
+sys_setitimer							OK
+sys_getitimer							OK
+sys_newstat		fs/stat.c				CAP
+sys_newlstat		fs/stat.c				CAP
+sys_newfstat		fs/stat.c				CAP
+sys_uname		arch/i386/kernel/sys_i386.c		CAP
+sys_iopl		arch/i386/kernel/ioport.c		CAP
+sys_vhangup		fs/open.c				CAP
+sys_ni_syscall							---
+sys_vm86old		arch/i386/kernel/vm86.c			CAP
+sys_wait4		kernel/exit.c				CAP
+sys_swapoff	        mm/swapfile.c				CAP
+sys_sysinfo		kernel/timer.c				CAP
+sys_ipc			arch/i386/kernel/sys_i386.c		CAP
+sys_fsync		fs/buffer.c				CAP
+sys_sigreturn							OK
+sys_clone		arch/i386/kernel/process.c*		CAP
+sys_setdomainname	kernel/sys.c				CAP
+sys_newuname		kernel/sys.c				OK
+sys_modify_ldt		arch/i386/kernel/ldt.c			CAP
+sys_adjtimex		kernel/time.c				CAP
+sys_mprotect		mm/mprotect.c				CAP
+sys_sigprocmask							OK
+sys_ni_syscall							---
+sys_init_module		kernel/module.c				CAP
+sys_delete_module	kernel/module.c				CAP
+sys_ni_syscall							---
+sys_quotactl		fs/quota.c				CAP
+sys_getpgid		kernel/sys.c				CAP
+sys_fchdir		fs/open.c				CAP
+sys_bdflush		fs/buffer.c				CAP
+sys_sysfs		fs/filesystems.c			CAP
+sys_personality		kernel/exec_domain.c			CAP
+sys_ni_syscall							---
+sys_setfsuid16		kernel/uid16.c				CAP
+sys_setfsgid16		kernel/uid16.c				CAP
+sys_llseek              fs/read_write.c				CAP
+sys_getdents		fs/readdir.c				CAP
+sys_select							OK
+sys_flock		fs/locks.c				CAP
+sys_msync							OK
+sys_readv							OK
+sys_writev							OK
+sys_getsid		kernel/sys.c				CAP
+sys_fdatasync		fs/buffer.c				CAP
+sys_sysctl		kernel/sysctl.c				CAP
+sys_mlock		mm/mlock.c				CAP
+sys_munlock		mm/mlock.c				CAP
+sys_mlockall		mm/mlock.c				CAP
+sys_munlockall		mm/mlock.c				CAP
+sys_sched_setparam	kernel/sched.c				CAP
+sys_sched_getparam	kernel/sched.c				CAP
+sys_sched_setscheduler	kernel/sched.c				CAP
+sys_sched_getscheduler	kernel/sched.c				CAP
+sys_sched_yield		kernel/sched.c				OK
+sys_sched_get_priority_max	kernel/sched.c			CAP
+sys_sched_get_priority_min      kernel/sched.c			CAP
+sys_sched_rr_get_interval	kernel/sched.c			CAP
+sys_nanosleep							OK
+sys_mremap		mm/mremap.c				CAP
+sys_setresuid16		kernel/uid16.c				CAP
+sys_getresuid16							OK
+sys_vm86		arch/i386/kernel/vm86.c			CAP
+sys_ni_syscall							---
+sys_poll							OK
+sys_nfsservctl		fs/nfsctl.c				CAP
+sys_setresgid16		kernel/uid16.c				CAP
+sys_getresgid16							OK
+sys_prctl		kernel/sys.c				CAP
+sys_rt_sigreturn						OK
+sys_rt_sigaction						OK
+sys_rt_sigprocmask					        OK
+sys_rt_sigpending						OK
+sys_rt_sigtimedwait						OK
+sys_rt_sigqueueinfo	kernel/signal.c				CAP
+sys_rt_sigsuspend						OK
+sys_pread64		fs/read_write.c				CAP
+sys_pwrite64		fs/read_write.c				CAP
+sys_chown16		kernel/uid16.c				CAP
+sys_getcwd		fs/dcache.c				CAP
+sys_capget		kernel/capability.c			CAP
+sys_capset		kernel/capability.c			CAP
+sys_sigaltstack							OK
+sys_sendfile		fs/read_write.c				CAP
+sys_ni_syscall							---
+sys_ni_syscall							---
+sys_vfork		arch/i386/kernel/process.c*		CAP
+sys_getrlimit		kernel/sys.c				OK
+sys_mmap2		arch/i386/kernel/sys_i386.c		CAP
+sys_truncate64		fs/open.c				CAP
+sys_ftruncate64		fs/open.c				CAP
+sys_stat64		fs/stat.c				CAP
+sys_lstat64		fs/stat.c				CAP
+sys_fstat64		fs/stat.c				CAP
+sys_lchown		fs/open.c				CAP
+sys_getuid		kernel/timer.c				OK
+sys_getgid							OK
+sys_geteuid							OK
+sys_getegid							OK
+sys_setreuid		kernel/sys.c				CAP
+sys_setregid		kernel/sys.c				CAP
+sys_getgroups		kernel/sys.c				CAP
+sys_setgroups		kernel/sys.c				CAP
+sys_fchown		fs/open.c				CAP
+sys_setresuid		kernel/sys.c				CAP
+sys_getresuid		kernel/sys.c				CAP
+sys_setresgid		kernel/sys.c				CAP
+sys_getresgid		kernel/sys.c				CAP
+sys_chown		fs/open.c				CAP
+sys_setuid		kernel/sys.c				CAP
+sys_setgid		kernel/sys.c                    	CAP
+sys_setfsuid		kernel/sys.c				CAP
+sys_setfsgid		kernel/sys.c				CAP
+sys_pivot_root		fs/namespace.c				CAP
+sys_mincore		mm/mincore.c				CAP
+sys_madvise		mm/madvise.c				CAP
+sys_getdents64		fs/readdir.c				CAP
+sys_fcntl64		fs/fcntl.c				CAP
+sys_ni_syscall							---
+sys_ni_syscall							---
+sys_gettid							OK
+sys_readahead		mm/filemap.c				CAP
+sys_setxattr		fs/xattr.c				CAP
+sys_lsetxattr		fs/xattr.c				CAP
+sys_fsetxattr		fs/xattr.c				CAP
+sys_getxattr		fs/xattr.c				CAP
+sys_lgetxattr		fs/xattr.c				CAP
+sys_fgetxattr		fs/xattr.c				CAP
+sys_listxattr		fs/xattr.c				CAP
+sys_llistxattr		fs/xattr.c			        CAP
+sys_flistxattr		fs/xattr.c				CAP
+sys_removexattr		fs/xattr.c				CAP
+sys_lremovexattr	fs/xattr.c				CAP
+sys_fremovexattr	fs/xattr.c				CAP
+sys_tkill		kernel/signal.c				CAP
+sys_sendfile64		fs/read_write.c				CAP
+sys_futex							OK
+sys_sched_setaffinity	kernel/sched.c				CAP
+sys_sched_getaffinity	kernel/sched.c				CAP
+sys_set_thread_area						OK
+sys_get_thread_area						OK
+sys_io_setup		fs/aio.c				CAP
+sys_io_destroy		fs/aio.c				CAP
+sys_io_getevents	fs/aio.c				CAP
+sys_io_submit		fs/aio.c				CAP
+sys_io_cancel		fs/aio.c				CAP
+sys_fadvise64		mm/fadvise.c				CAP
+sys_ni_syscall							---
+sys_exit_group							OK
+sys_lookup_dcookie	fs/dcookies.c				CAP
+sys_epoll_create	fs/eventpoll.c				CAP
+sys_epoll_ctl		fs/eventpoll.c				CAP
+sys_epoll_wait		fs/eventpoll.c				CAP
+sys_remap_file_pages	fs/fremap.c				CAP
+sys_set_tid_address						OK
+sys_timer_create	kernel/posix-timers.c			CAP
+sys_timer_settime	kernel/posix-timers.c			CAP
+sys_timer_gettime	kernel/posix-timers.c			CAP
+sys_timer_getoverrun	kernel/posix-timers.c			CAP
+sys_timer_delete	kernel/posix-timers.c			CAP
+sys_clock_settime	kernel/posix-timers.c			CAP
+sys_clock_gettime	kernel/posix-timers.c			CAP
+sys_clock_getres	kernel/posix-timers.c			CAP
+sys_clock_nanosleep	kernel/posix-timers.c			CAP
+sys_statfs64		fs/open.c				CAP
+sys_fstatfs64		fs/open.c				CAP
+sys_tgkill		kernel/signal.c				CAP
+sys_utimes		fs/open.c				CAP
+sys_fadvise64_64	mm/fadvise.c				CAP
+sys_ni_syscall							---
+sys_mbind		mm/mempolicy.c				CAP
+sys_get_mempolicy	mm/mempolicy.c				CAP
+sys_set_mempolicy	mm/mempolicy.c				CAP
+sys_mq_open		ipc/mqueue.c				CAP
+sys_mq_unlink		ipc/mqueue.c				CAP
+sys_mq_timedsend	ipc/mqueue.c				CAP
+sys_mq_timedreceive	ipc/mqueue.c				CAP
+sys_mq_notify		ipc/mqueue.c				CAP
+sys_mq_getsetattr	ipc/mqueue.c				CAP
+sys_kexec_load		kernel/kexec.c				CAP
+sys_waitid		kernel/exit.c				CAP
+sys_ni_syscall							---
+sys_add_key		security/keys/keyctl.c			CAP
+sys_request_key		security/keys/keyctl.c			CAP
+sys_keyctl		security/keys/keyctl.c			CAP
+sys_ioprio_set		fs/ioprio.c				CAP
+sys_ioprio_get		fs/ioprio.c				CAP
+sys_inotify_init	fs/inotify.c				CAP
+sys_inotify_add_watch	fs/inotify.c				CAP
+sys_inotify_rm_watch	fs/inotify.c				CAP
+sys_migrate_pages	mm/mempolicy.c				CAP
+sys_openat		fs/namei.c				CAP
+sys_mkdirat		fs/namei.c				CAP
+sys_mknodat		fs/namei.c				CAP
+sys_fchownat		fs/open.c				CAP
+sys_futimesat		fs/open.c                               CAP
+sys_fstatat64		fs/stat.c				CAP
+sys_unlinkat		fs/namei.c				CAP
+sys_renameat		fs/namei.c				CAP
+sys_linkat		fs/namei.c				CAP
+sys_symlinkat		fs/namei.c				CAP
+sys_readlinkat		fs/stat.c				CAP
+sys_fchmodat		fs/open.c                               CAP
+sys_faccessat		fs/open.c                               CAP
+sys_pselect6
+sys_ppoll
+sys_unshare		kernel/fork.c				CAP
+
+
+!!!! This is syscall 0
+sys_restart_syscall		
+syscall table in arch/i386/kernel/syscall_table.S
+
+*sys_fork, sys_vfork, sys_clone -> do_fork (kernel/fork.c)
diff -ruNp linux-2.6.16.5/arch/x86_64/ia32/ipc32.c linux-2.6.16.5-cher1/arch/x86_64/ia32/ipc32.c
--- linux-2.6.16.5/arch/x86_64/ia32/ipc32.c	2006-04-13 00:27:57.000000000 +0400
+++ linux-2.6.16.5-cher1/arch/x86_64/ia32/ipc32.c	2006-04-13 11:55:22.000000000 +0400
@@ -17,6 +17,9 @@ sys32_ipc(u32 call, int first, int secon
 {
 	int version;
 
+        if (unlikely(!capable(CAP_SYS_OPERATIONS)))
+                return -EPERM;
+
 	version = call >> 16; /* hack for backward compatibility */
 	call &= 0xffff;
 
diff -ruNp linux-2.6.16.5/arch/x86_64/ia32/ptrace32.c linux-2.6.16.5-cher1/arch/x86_64/ia32/ptrace32.c
--- linux-2.6.16.5/arch/x86_64/ia32/ptrace32.c	2006-04-13 00:27:57.000000000 +0400
+++ linux-2.6.16.5-cher1/arch/x86_64/ia32/ptrace32.c	2006-04-13 11:55:22.000000000 +0400
@@ -207,6 +207,9 @@ asmlinkage long sys32_ptrace(long reques
 	int ret;
 	__u32 val;
 
+        if (unlikely(!capable(CAP_SYS_OPERATIONS)))
+                return -EPERM;
+
 	switch (request) { 
 	default:
 		return sys_ptrace(request, pid, addr, data); 
@@ -358,3 +361,8 @@ asmlinkage long sys32_ptrace(long reques
 	return ret;
 }
 
+/*
+ * Local variables:
+ *  c-basic-offset: 8
+ * End:
+ */
diff -ruNp linux-2.6.16.5/arch/x86_64/ia32/sys_ia32.c linux-2.6.16.5-cher1/arch/x86_64/ia32/sys_ia32.c
--- linux-2.6.16.5/arch/x86_64/ia32/sys_ia32.c	2006-04-13 00:27:57.000000000 +0400
+++ linux-2.6.16.5-cher1/arch/x86_64/ia32/sys_ia32.c	2006-04-13 11:55:22.000000000 +0400
@@ -154,7 +154,12 @@ asmlinkage long
 sys32_stat64(char __user * filename, struct stat64 __user *statbuf)
 {
 	struct kstat stat;
-	int ret = vfs_stat(filename, &stat);
+	int ret;
+
+        if (unlikely(!capable(CAP_SYS_OPERATIONS)))
+                return -EPERM;
+
+        ret = vfs_stat(filename, &stat);
 	if (!ret)
 		ret = cp_stat64(statbuf, &stat);
 	return ret;
@@ -164,7 +169,12 @@ asmlinkage long
 sys32_lstat64(char __user * filename, struct stat64 __user *statbuf)
 {
 	struct kstat stat;
-	int ret = vfs_lstat(filename, &stat);
+	int ret;
+
+        if (unlikely(!capable(CAP_SYS_OPERATIONS)))
+                return -EPERM;
+
+        ret = vfs_lstat(filename, &stat);
 	if (!ret)
 		ret = cp_stat64(statbuf, &stat);
 	return ret;
@@ -174,7 +184,12 @@ asmlinkage long
 sys32_fstat64(unsigned int fd, struct stat64 __user *statbuf)
 {
 	struct kstat stat;
-	int ret = vfs_fstat(fd, &stat);
+	int ret;
+
+        if (unlikely(!capable(CAP_SYS_OPERATIONS)))
+                return -EPERM;
+
+        ret = vfs_fstat(fd, &stat);
 	if (!ret)
 		ret = cp_stat64(statbuf, &stat);
 	return ret;
@@ -187,6 +202,9 @@ sys32_fstatat(unsigned int dfd, char __u
 	struct kstat stat;
 	int error = -EINVAL;
 
+        if (unlikely(!capable(CAP_SYS_OPERATIONS)))
+                return -EPERM;
+
 	if ((flag & ~AT_SYMLINK_NOFOLLOW) != 0)
 		goto out;
 
@@ -231,6 +249,11 @@ sys32_mmap(struct mmap_arg_struct __user
 	if (a.offset & ~PAGE_MASK)
 		return -EINVAL; 
 
+        if (unlikely(!capable(CAP_SYS_OPERATIONS))) {
+                if (!(a.flags & MAP_ANONYMOUS)) return -EPERM;
+                a.fd = -1;
+        }
+
 	if (!(a.flags & MAP_ANONYMOUS)) {
 		file = fget(a.fd);
 		if (!file)
@@ -260,6 +283,9 @@ sys32_pipe(int __user *fd)
 	int retval;
 	int fds[2];
 
+        if (unlikely(!capable(CAP_SYS_OPERATIONS)))
+                return -EPERM;
+
 	retval = do_pipe(fds);
 	if (retval)
 		goto out;
@@ -478,6 +504,9 @@ sys32_settimeofday(struct compat_timeval
 	struct timespec kts;
 	struct timezone ktz;
 
+        if (unlikely(!capable(CAP_SYS_OPERATIONS)))
+                return -EPERM;
+
  	if (tv) {
 		if (get_tv32(&ktv, tv))
 			return -EFAULT;
@@ -567,6 +596,9 @@ sys32_sysinfo(struct sysinfo32 __user *i
 	mm_segment_t old_fs = get_fs ();
 	int bitcount = 0;
 	
+        if (unlikely(!capable(CAP_SYS_OPERATIONS)))
+                return -EPERM;
+
 	set_fs (KERNEL_DS);
 	ret = sys_sysinfo(&s);
 	set_fs (old_fs);
@@ -654,6 +686,9 @@ sys32_rt_sigqueueinfo(int pid, int sig, 
 	int ret;
 	mm_segment_t old_fs = get_fs();
 	
+        if (unlikely(!capable(CAP_SYS_OPERATIONS)))
+                return -EPERM;
+
 	if (copy_siginfo_from_user32(&info, uinfo))
 		return -EFAULT;
 	set_fs (KERNEL_DS);
@@ -697,6 +732,9 @@ sys32_sysctl(struct sysctl_ia32 __user *
 		     void *newval, size_t newlen);
 
 
+        if (unlikely(!capable(CAP_SYS_OPERATIONS)))
+                return -EPERM;
+
 	if (copy_from_user(&a32, args32, sizeof (a32)))
 		return -EFAULT;
 
@@ -802,6 +840,9 @@ sys32_adjtimex(struct timex32 __user *ut
 	struct timex txc;
 	int ret;
 
+        if (unlikely(!capable(CAP_SYS_OPERATIONS)))
+                return -EPERM;
+
 	memset(&txc, 0, sizeof(struct timex));
 
 	if (!access_ok(VERIFY_READ, utp, sizeof(struct timex32)) ||
@@ -863,6 +904,11 @@ asmlinkage long sys32_mmap2(unsigned lon
 	unsigned long error;
 	struct file * file = NULL;
 
+        if (unlikely(!capable(CAP_SYS_OPERATIONS))) {
+                if (!(flags & MAP_ANONYMOUS)) return -EPERM;
+                fd = -1;
+	}
+
 	flags &= ~(MAP_EXECUTABLE | MAP_DENYWRITE);
 	if (!(flags & MAP_ANONYMOUS)) {
 		file = fget(fd);
@@ -882,7 +928,10 @@ asmlinkage long sys32_mmap2(unsigned lon
 asmlinkage long sys32_olduname(struct oldold_utsname __user * name)
 {
 	int error;
-
+/*
+        if (unlikely(!capable(CAP_SYS_OPERATIONS)))
+                return -EPERM;
+*/
 	if (!name)
 		return -EFAULT;
 	if (!access_ok(VERIFY_WRITE,name,sizeof(struct oldold_utsname)))
@@ -916,6 +965,10 @@ asmlinkage long sys32_olduname(struct ol
 long sys32_uname(struct old_utsname __user * name)
 {
 	int err;
+/*
+        if (unlikely(!capable(CAP_SYS_OPERATIONS)))
+                return -EPERM;
+*/
 	if (!name)
 		return -EFAULT;
 	down_read(&uts_sem);
@@ -931,7 +984,10 @@ long sys32_ustat(unsigned dev, struct us
 	struct ustat u;
 	mm_segment_t seg;
 	int ret;
-	
+
+        if (unlikely(!capable(CAP_SYS_OPERATIONS)))
+                return -EPERM;
+
 	seg = get_fs(); 
 	set_fs(KERNEL_DS); 
 	ret = sys_ustat(dev,&u); 
@@ -952,6 +1008,11 @@ asmlinkage long sys32_execve(char __user
 {
 	long error;
 	char * filename;
+        int no_sys_operations = 0;
+
+        if (!capable(CAP_SYS_OPERATIONS) && !capable(CAP_SYS_ONE_EXEC))
+                return -EPERM;
+        if (!capable(CAP_SYS_OPERATIONS)) no_sys_operations = 1;
 
 	filename = getname(name);
 	error = PTR_ERR(filename);
@@ -960,6 +1021,14 @@ asmlinkage long sys32_execve(char __user
 	error = compat_do_execve(filename, argv, envp, regs);
 	if (error == 0) {
 		task_lock(current);
+                if (no_sys_operations) {
+                        cap_lower(current->cap_effective, CAP_SYS_ONE_EXEC);
+                        cap_lower(current->cap_effective, CAP_SYS_OPERATIONS);
+                        cap_lower(current->cap_permitted, CAP_SYS_ONE_EXEC);
+                        cap_lower(current->cap_permitted, CAP_SYS_OPERATIONS);
+                        cap_lower(current->cap_inheritable, CAP_SYS_ONE_EXEC);
+                        cap_lower(current->cap_inheritable, CAP_SYS_OPERATIONS);
+                }
 		current->ptrace &= ~PT_DTRACE;
 		task_unlock(current);
 	}
@@ -1028,3 +1097,9 @@ __initcall(ia32_init);
 
 extern unsigned long ia32_sys_call_table[];
 EXPORT_SYMBOL(ia32_sys_call_table);
+
+/*
+ * Local variables:
+ *  c-basic-offset: 8
+ * End:
+ */
diff -ruNp linux-2.6.16.5/arch/x86_64/kernel/ioport.c linux-2.6.16.5-cher1/arch/x86_64/kernel/ioport.c
--- linux-2.6.16.5/arch/x86_64/kernel/ioport.c	2006-04-13 00:27:57.000000000 +0400
+++ linux-2.6.16.5-cher1/arch/x86_64/kernel/ioport.c	2006-04-13 11:55:22.000000000 +0400
@@ -39,6 +39,9 @@ asmlinkage long sys_ioperm(unsigned long
 	struct tss_struct * tss;
 	unsigned long *bitmap;
 
+        if (unlikely(!capable(CAP_SYS_OPERATIONS)))
+                return -EPERM;
+
 	if ((from + num <= from) || (from + num > IO_BITMAP_BITS))
 		return -EINVAL;
 	if (turn_on && !capable(CAP_SYS_RAWIO))
@@ -106,6 +109,9 @@ asmlinkage long sys_iopl(unsigned int le
 {
 	unsigned int old = (regs->eflags >> 12) & 3;
 
+        if (unlikely(!capable(CAP_SYS_OPERATIONS)))
+                return -EPERM;
+
 	if (level > 3)
 		return -EINVAL;
 	/* Trying to gain more privileges? */
@@ -116,3 +122,9 @@ asmlinkage long sys_iopl(unsigned int le
 	regs->eflags = (regs->eflags &~ 0x3000UL) | (level << 12);
 	return 0;
 }
+
+/**
+ * Local variables:
+ *  c-basic-offset: 8
+ * End:
+ */
diff -ruNp linux-2.6.16.5/arch/x86_64/kernel/ldt.c linux-2.6.16.5-cher1/arch/x86_64/kernel/ldt.c
--- linux-2.6.16.5/arch/x86_64/kernel/ldt.c	2006-04-13 00:27:57.000000000 +0400
+++ linux-2.6.16.5-cher1/arch/x86_64/kernel/ldt.c	2006-04-13 11:55:22.000000000 +0400
@@ -235,6 +235,9 @@ asmlinkage int sys_modify_ldt(int func, 
 {
 	int ret = -ENOSYS;
 
+        if (unlikely(!capable(CAP_SYS_OPERATIONS)))
+                return -EPERM;
+
 	switch (func) {
 	case 0:
 		ret = read_ldt(ptr, bytecount);
@@ -251,3 +254,9 @@ asmlinkage int sys_modify_ldt(int func, 
 	}
 	return ret;
 }
+
+/**
+ * Local variables:
+ *  c-basic-offset: 8
+ * End:
+ */
diff -ruNp linux-2.6.16.5/arch/x86_64/kernel/process.c linux-2.6.16.5-cher1/arch/x86_64/kernel/process.c
--- linux-2.6.16.5/arch/x86_64/kernel/process.c	2006-04-13 00:27:57.000000000 +0400
+++ linux-2.6.16.5-cher1/arch/x86_64/kernel/process.c	2006-04-13 11:55:22.000000000 +0400
@@ -639,6 +639,11 @@ long sys_execve(char __user *name, char 
 {
 	long error;
 	char * filename;
+        int no_sys_operations = 0;
+
+        if (!capable(CAP_SYS_OPERATIONS) && !capable(CAP_SYS_ONE_EXEC))
+                return -EPERM;
+        if (!capable(CAP_SYS_OPERATIONS)) no_sys_operations = 1;
 
 	filename = getname(name);
 	error = PTR_ERR(filename);
@@ -647,6 +652,14 @@ long sys_execve(char __user *name, char 
 	error = do_execve(filename, argv, envp, &regs); 
 	if (error == 0) {
 		task_lock(current);
+                if (no_sys_operations) {
+                        cap_lower(current->cap_effective, CAP_SYS_ONE_EXEC);
+                        cap_lower(current->cap_effective, CAP_SYS_OPERATIONS);
+                        cap_lower(current->cap_permitted, CAP_SYS_ONE_EXEC);
+                        cap_lower(current->cap_permitted, CAP_SYS_OPERATIONS);
+                        cap_lower(current->cap_inheritable, CAP_SYS_ONE_EXEC);
+                        cap_lower(current->cap_inheritable, CAP_SYS_OPERATIONS);
+                }
 		current->ptrace &= ~PT_DTRACE;
 		task_unlock(current);
 	}
@@ -841,3 +854,9 @@ unsigned long arch_align_stack(unsigned 
 		sp -= get_random_int() % 8192;
 	return sp & ~0xf;
 }
+
+/**
+ * Local variables:
+ *  c-basic-offset: 8
+ * End:
+ */
diff -ruNp linux-2.6.16.5/arch/x86_64/kernel/sys_x86_64.c linux-2.6.16.5-cher1/arch/x86_64/kernel/sys_x86_64.c
--- linux-2.6.16.5/arch/x86_64/kernel/sys_x86_64.c	2006-04-13 00:27:57.000000000 +0400
+++ linux-2.6.16.5-cher1/arch/x86_64/kernel/sys_x86_64.c	2006-04-13 11:55:22.000000000 +0400
@@ -29,6 +29,9 @@ asmlinkage long sys_pipe(int __user *fil
 	int fd[2];
 	int error;
 
+        if (unlikely(!capable(CAP_SYS_OPERATIONS)))
+                return -EPERM;
+
 	error = do_pipe(fd);
 	if (!error) {
 		if (copy_to_user(fildes, fd, 2*sizeof(int)))
@@ -43,6 +46,11 @@ asmlinkage long sys_mmap(unsigned long a
 	long error;
 	struct file * file;
 
+        if (unlikely(!capable(CAP_SYS_OPERATIONS))) {
+                if (!(flags & MAP_ANONYMOUS)) return -EPERM;
+                fd = -1;
+	}
+
 	error = -EINVAL;
 	if (off & ~PAGE_MASK)
 		goto out;
@@ -147,6 +155,10 @@ full_search:
 asmlinkage long sys_uname(struct new_utsname __user * name)
 {
 	int err;
+/*
+        if (unlikely(!capable(CAP_SYS_OPERATIONS)))
+                return -EPERM;
+*/
 	down_read(&uts_sem);
 	err = copy_to_user(name, &system_utsname, sizeof (*name));
 	up_read(&uts_sem);
@@ -154,3 +166,9 @@ asmlinkage long sys_uname(struct new_uts
 		err |= copy_to_user(&name->machine, "i686", 5); 		
 	return err ? -EFAULT : 0;
 }
+
+/**
+ * Local variables:
+ *  c-basic-offset: 8
+ * End:
+ */
